Package org.eclipse.jgit.treewalk

## Class NameConflictTreeWalk

- java.lang.Object
- - org.eclipse.jgit.treewalk.TreeWalk
  - - org.eclipse.jgit.treewalk.NameConflictTreeWalk

    public class NameConflictTreeWalk
    extends TreeWalk

Specialized TreeWalk to detect directory-file (D/F) name conflicts.

Due to the way a Git tree is organized the standard `TreeWalk` won't easily find a D/F conflict when merging two or more trees together. In the standard TreeWalk the file will be returned first, and then much later the directory will be returned. This makes it impossible for the application to efficiently detect and handle the conflict.

Using this walk implementation causes the directory to report earlier than usual, at the same time as the non-directory entry. This permits the application to handle the D/F conflict in a single step. The directory is returned only once, so it does not get returned later in the iteration.

When a D/F conflict is detected `TreeWalk.isSubtree()` will return true and `TreeWalk.enterSubtree()` will recurse into the subtree, no matter which iterator originally supplied the subtree.

Because conflicted directories report early, using this walk implementation to populate a `DirCacheBuilder` may cause the automatic resorting to run and fix the entry ordering.

This walk implementation requires more CPU to implement a look-ahead and a look-behind to merge a D/F pair together, or to skip a previously reported directory. In typical Git repositories the look-ahead cost is 0 and the look-behind doesn't trigger, as users tend not to create trees which contain both "foo" as a directory and "foo.c" as a file.

In the worst-case however several thousand look-ahead steps per walk step may be necessary, making the overhead quite significant. Since this worst-case should never happen this walk implementation has made the time/space tradeoff in favor of more-time/less-space, as that better suits the typical case.

### Constructor Summary

Constructors
`NameConflictTreeWalk​(ObjectReader or)` Create a new tree walker for a given repository.
`NameConflictTreeWalk​(Repository repo)` Create a new tree walker for a given repository.

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `isDirectoryFileConflict()` True if the current entry is covered by a directory/file conflict.

### Methods inherited from class org.eclipse.jgit.treewalk.TreeWalk

`addTree, addTree, enterSubtree, forPath, forPath, forPath, getDepth, getFileMode, getFilter, getNameString, getObjectId, getObjectId, getObjectReader, getPathLength, getPathString, getRawMode, getRawPath, getTree, getTreeCount, idEqual, isPathPrefix, isPathSuffix, isPostChildren, isPostOrderTraversal, isRecursive, isSubtree, next, release, reset, reset, reset, setFilter, setPostOrderTraversal, setRecursive`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### NameConflictTreeWalk

    public NameConflictTreeWalk​(Repository repo)

Create a new tree walker for a given repository.

Parameters:
  `repo` - the repository the walker will obtain data from.

#### NameConflictTreeWalk

    public NameConflictTreeWalk​(ObjectReader or)

Create a new tree walker for a given repository.

Parameters:
  `or` - the reader the walker will obtain tree data from.

### Method Detail

#### isDirectoryFileConflict

    public boolean isDirectoryFileConflict()

True if the current entry is covered by a directory/file conflict. This means that for some prefix of the current entry's path, this walk has detected a directory/file conflict. Also true if the current entry itself is a directory/file conflict. Example: If this TreeWalk points to foo/bar/a.txt and this method returns true then you know that either for path foo or for path foo/bar files and folders were detected.

Returns:
  `true` if the current entry is covered by a directory/file conflict, `false` otherwise